--[[
%% properties
98 sceneActivation
%% events
%% globals
--]]

local RGBs = {175, 176, 177} -- IDs of RGB as Array {X, Y, Z}
local fibaroID = 98 -- Set ID of Device which shall dim RGB
local sceneID = 8 -- Set ID of this scene

local stepPercentage = 7 -- Dimmer step in percent
local stepTime = 0.05 -- Dimmer step duration in seconds
local toggleTime = 5 -- Time to toggle dim up/down

---- Do not modify code below that line ----

function dimRGB (rgbID, step)
  
  local valueDimmer = tonumber(fibaro:getValue(rgbID, "brightness")) + step

  if valueDimmer < 1 then 
    if valueDimmer == 1 + step then return end;
    valueDimmer = 1
  end 
  if valueDimmer > 100 then 
    if valueDimmer == 100 + step then return end;
    valueDimmer = 100 
  end

  -- fibaro:debug("RGB " .. rgbID ..": ".. valueDimmer) 
  fibaro:call(rgbID, "setBrightness", valueDimmer)
    
end

local startSource = fibaro:getSourceTrigger();
if (
 ( tonumber(fibaro:getValue(fibaroID, "sceneActivation")) == 26 )
or
startSource["type"] == "other"
)
then
    -- Click
	local deviceValue1 = tonumber(fibaro:getValue(RGBs[1], "brightness"))

	if (deviceValue1 > 0) then
      for i, iRGB in ipairs(RGBs) do 
    	fibaro:call(iRGB, "turnOff")
      end
	else
      for i, iRGB in ipairs(RGBs) do 
    	fibaro:call(iRGB, "turnOn")
      end
	end

elseif  ( tonumber(fibaro:getValue(fibaroID, "sceneActivation")) == 22 ) then

  -- Hold
    local dimUpDown = fibaro:getGlobal("dimUpDown") 
    local lastDimToggle = fibaro:getGlobal("lastDimToggle") 
  
    -- always start a new dim with dimming up
    if os.time() - lastDimToggle > toggleTime then dimUpDown = 1 end

    -- if off, switch on and dim up from darkest
    local deviceValue1 = tonumber(fibaro:getValue(RGBs[1], "brightness"))
	if (deviceValue1 == 0) then
      for i, iRGB in ipairs(RGBs) do 
        fibaro:call(iRGB, "setBrightness", "1")
      end
      dimUpDown = 1
    end  
    
    -- if maximum brighntess start wich dimming down
    if tonumber(fibaro:getValue(RGBs[1], "brightness")) == 100 then dimUpDown = -1 end

    fibaro:setGlobal("dimUpDown", dimUpDown * -1)  
    local step = math.floor(100 / 100 * stepPercentage * dimUpDown)
  
  	-- Start dim loop
    print ("Start dim",step)
  	repeat 
      for i, iRGB in ipairs(RGBs) do 
        dimRGB (iRGB, step)	
	  end
      fibaro:sleep(1000 * stepTime)
    until false
  
elseif ( tonumber(fibaro:getValue(fibaroID, "sceneActivation")) == 23 ) then
  
	-- Release
  	print ("Stop")
    fibaro:setGlobal("lastDimToggle", os.time())  
  	fibaro:killScenes(sceneID)

elseif ( tonumber(fibaro:getValue(fibaroID, "sceneActivation")) == 24 ) then
  
	-- Double Click
  	print ("Setting maximum")
    for i, iRGB in ipairs(RGBs) do 
      dimRGB (iRGB, 100)	
    end

end